/*
 * (c) 2003-2016 MuleSoft, Inc. The software in this package is
 * published under the terms of the Commercial Free Software license V.1, a copy of which
 * has been included with this distribution in the LICENSE.md file.
 */
angular.module('demoController', []).controller('CustomerCtrl', ['$scope', '$http', 'Rest', function($scope, $http, Rest) {

    Rest.loadSchemaKey('http://localhost:8082/app/schemas/customer.json', $scope, "schemaObject")
    Rest.loadSchemaKey('http://localhost:8082/app/schemas/customerList.json', $scope, "listSchemaObject")



    // Set default ng-include html template
    $scope.templateUrl = 'customer/createCustomer.html'
    $scope.setTemplate = function(template) {
        $scope.templateUrl = template
    }

    $scope.operations = [{
        template: "customer/createCustomer.html",
        name: "Create"
    }, {
        template: "customer/getCustomer.html",
        name: "Get"
    }, {
        template: "customer/updateCustomer.html",
        name: "Update"
    }, {
        template: "customer/deleteCustomer.html",
        name: "Delete"
    }, {
        template: "customer/getCustomerList.html",
        name: "Get Customers"
    }]


    $scope.get = function() {
        console.log("getCustomer")
        Rest.doPost('http://localhost:8082/getCustomer', $scope.schemaObject, $scope , "response")
    }

    $scope.create = function() {
        console.log("createCustomer")
        Rest.doPost('http://localhost:8082/createCustomer', $scope.schemaObject, $scope, "response")
    }

    $scope.update = function() {
        console.log("updateCustomer")
        Rest.doPost('http://localhost:8082/updateCustomer', $scope.schemaObject, $scope, "response")
    }

    $scope.delete = function() {
        console.log("deleteCustomer")
        Rest.doPost('http://localhost:8082/deleteCustomer', $scope.schemaObject, $scope, "response")
    }

    $scope.getList = function() {
        console.log("getList of Customers")
        Rest.doPostList('http://localhost:8082/getCustomerList', $scope.listSchemaObject, $scope, "listResponse")
    }

}]);
