/*
 * (c) 2003-2016 MuleSoft, Inc. The software in this package is
 * published under the terms of the Commercial Free Software license V.1, a copy of which
 * has been included with this distribution in the LICENSE.md file.
 */
angular.module('demoController').controller('PurchaseOrderCtrl', ['$scope', '$http', 'Rest', function($scope, $http, Rest) {

    Rest.loadSchemaKey('http://localhost:8082/app/schemas/purchaseOrder.json', $scope, "schemaObject")
    Rest.loadSchemaKey('http://localhost:8082/app/schemas/purchaseOrderList.json', $scope, "listSchemaObject")

    // Set default ng-include html template
    $scope.templateUrl = 'purchaseOrder/createPurchaseOrder.html'

    $scope.setTemplate = function(template) {
        $scope.templateUrl = template
    }

    $scope.operations = [{
        template: "purchaseOrder/createPurchaseOrder.html",
        name: "Create"
    }, {
        template: "purchaseOrder/deletePurchaseOrder.html",
        name: "Delete"
    }, {
        template: "purchaseOrder/getPurchaseOrderList.html",
        name: "Get Purchase Orders"
    }]


    $scope.create = function() {
        console.log("createPurchaseOrder")
        console.log($scope.schemaObject)

        Rest.doPost('http://localhost:8082/createPurchaseOrder', $scope.schemaObject, $scope, "response")
    }

    $scope.delete = function() {
        console.log("deletePurchaseOrder")
        Rest.doPost('http://localhost:8082/deletePurchaseOrder', $scope.schemaObject, $scope, "response")
    }

    $scope.getList = function() {
        console.log("getList of Purchase Orders")
        Rest.doPostList('http://localhost:8082/getPurchaseOrderList', $scope.listSchemaObject, $scope, "listResponse")
    }

}]);
