/*
 * (c) 2003-2016 MuleSoft, Inc. The software in this package is
 * published under the terms of the Commercial Free Software license V.1, a copy of which
 * has been included with this distribution in the LICENSE.md file.
 */
angular.module('demoController').controller('InvoiceCtrl', ['$scope', '$http', 'Rest', function($scope, $http, Rest) {

    Rest.loadSchemaKey('http://localhost:8082/app/schemas/salesInvoice.json', $scope, "schemaObject")
    Rest.loadSchemaKey('http://localhost:8082/app/schemas/salesInvoiceList.json', $scope, "listSchemaObject")

    // Set default ng-include html template
    $scope.templateUrl = 'salesInvoice/createSalesInvoice.html'

    $scope.setTemplate = function(template) {
        $scope.templateUrl = template
    }

    $scope.operations = [{
        template: "salesInvoice/createSalesInvoice.html",
        name: "Create"
    }, {
        template: "salesInvoice/deleteSalesInvoice.html",
        name: "Delete"
    }, {
        template: "salesInvoice/getSalesInvoiceList.html",
        name: "Get Sales Invoices"
    }]


    $scope.create = function() {
        console.log("createSalesInvoice")
        Rest.doPost('http://localhost:8082/createSalesInvoice', $scope.schemaObject, $scope, "reponse")
    }

    $scope.delete = function() {
        console.log("deleteSalesInvoice")
        Rest.doPost('http://localhost:8082/deleteSalesInvoice', $scope.schemaObject, $scope, "reponse")
    }

    $scope.getList = function() {
        console.log("getList of Items")
        Rest.doPostList('http://localhost:8082/getSalesInvoiceList', $scope.listSchemaObject, $scope, "listResponse")
    }

}]);
