/*
 * (c) 2003-2016 MuleSoft, Inc. The software in this package is
 * published under the terms of the Commercial Free Software license V.1, a copy of which
 * has been included with this distribution in the LICENSE.md file.
 */
angular.module('restService', [])

.factory('Rest', function($http) {

    function isUndefinedOrEmpy(obj) {
        return (typeof obj === "undefined" || obj === "")
    }
    return {
        doPost: function(path, obj, scope, key) {
        	
        	blockUI();
        	
            var req = {
                method: 'POST',
                url: path,
                headers: {
                    'Content-Type': 'application/json'
                },
                data: JSON.stringify(obj)
            }
            $http(req).then(function successCallback(response) {
                /* GP returns 200 even when an exception is found during an operation
                    the block below check the format of response's data, succesful operations
                    return an empty or a JSON Object.
                */
                if(isUndefinedOrEmpy(response.data)){
                  alert("Successful operation");
                  return;
                }
                if (response.data instanceof Object) {
                    scope[key] = response.data;
                } else {
                    // Displays an alert with the exception message
                    alert(response.data);
                }
                unblockUI();
            }, function errorCallback(response) {
                alert(response.data);
                scope.exception = response.data;
                unblockUI();
            });
        },

        //TODO: refactor this method, duplicates doPost() code.
        doPostList: function(path, obj, scope, key) {
            var req = {
                method: 'POST',
                url: path,
                headers: {
                    'Content-Type': 'application/json'
                },
                data: JSON.stringify(obj)
            }
            $http(req).then(function successCallback(response) {
                /* GP returns 200 even when an exception is found during an operation
                    the block below check the format of response's data, succesful operations
                    return an empty or a JSON Object.
                */
                if (isUndefinedOrEmpy(response.data)) {
                    alert("Successful operation");
                    return;
                }
                if (response.data instanceof Object) {
                    console.log(response.data)
                    if (response.data.length > 3) {
                        scope[key] = response.data.slice(0, 3);

                    } else {
                        console.log("here")
                        scope[key] = response.data;
                    }
                } else {
                    // Displays an alert with the exception message
                    alert(response.data);
                }
                unblockUI();
            }, function errorCallback(response) {
                alert(response.data);
                scope.exception = response.data;
                unblockUI();
            });
        },

        loadSchemaKey: function(path, scope, key) {
            var req = {
                method: 'GET',
                url: path,
                headers: {
                    'Content-Type': 'application/json'
                }
            }
            $http(req).then(function successCallback(response) {
                scope[key] = response.data
            }, function errorCallback(response) {
                console.log("ERROR LOADING SCHEMA")
            });
        }

    }
    

    function blockUI() {
        var message = "Processing...";
        var loaderUrl = "http://i.giphy.com/lijuimVKUcwRa.gif";
        $('html').block({
            message: '<h4>' + message + '<br><br><img src=' + loaderUrl + ' height=32 width=32/></h4>',
            overlayCSS: {
                backgroundColor: '#000',
                opacity: 0.2,
                cursor: 'wait',
                fadeIn: 0
            },
            css: {
                padding: 20,
                margin: 0,
                top: '50%',
                left: '50%',
                width: '250px',
                textAlign: 'center',
                color: '#000',
                border: '0px solid #aaa',
                cursor: 'wait',
                '-webkit-border-radius': '5px',
                '-moz-border-radius': '5px',
            }
        });
    }

    function unblockUI() {
        $('html').unblock();
    }
    
});
